#!c:/perl/bin/perl
#追加モジュールとか使わずに、正規表現でいいかげんな処理してるので
#想定外のデータ送ってくると、いろいろまずい

#POSTされてくるデータ count
#保存済みコメントの情報を要求してくる時(おもに動画読み込み時)
#<count name="sm123"/>
#返答
#<result last_no="保存してある最後のコメント番号" total_count="合計" add_count="0"/>

#POSTされてくるデータ send
#保存すべきコメントを送ってくる時
#<send name="sm123" last_no="9999" total_count="2000"/><chat ほげほげ>ふがふが</chat>以下略
#packetとかthreadとかview_counterは送ってこない
#保存するデータ
#<chat ほげほげ>ふがふが</chat>改行
#<chat ほげほげ>ふがふが</chat>改行
#以下略
#「</chat>改行」をコメントの区切りとして判断してるので
#職人系書き込みは(コメントデータに改行とかが入る)壊れないはず
#FlashのXMLオブジェクト利用だと、<とか>とかはちゃんと$ltとか&btとかに変換されてくる
#返答
#<result last_no="保存してある最後のコメント番号" total_count="合計" add_count="追加した数"/>
#コメント保存時はlast_noが大事　これを見てswfは次のコメント追加分を送ってくる

#POSTされてくるデータ load
#コメントを要求してくる時
#<load name="sm123" from="1" to="1000"/>
#保存してあるコメントのfrom番目からto番目を要求
#コメントナンバーとは無関係
#返答
#<?xml version="1.0" encoding="UTF-8"?><chat ほげほげ>ふがふが</chat>以下略
#packet thread view_counterは送らない

use strict;
use Encode;
use utf8;
use open ':utf8';
binmode STDIN, ":utf8";
binmode STDOUT, ":utf8";


#open(LOG,"> log.txt");
#print(LOG "start\n");

my $XMLDir = "../niconico/xml/";#コメントのXMLのディレクトリ
my $last_no = 0;#保存されている最後のコメント番号
my $total_count = 0;#保存されているコメントの数

#POSTされたデータを適当に配列に
my $PostData = "";
read(STDIN, $PostData, $ENV{'CONTENT_LENGTH'});
my @PostDataArray = split(/(<\/chat>|\/>)/,$PostData);

#まずは名前sm99999を抜き出す
my $name = "";
if($PostDataArray[0] =~ / name=\"([asf][mz][0-9]+)\"/){
  $name = $1;
}else{
  print "Content-Type: text/plain\n";
  print "\n";
  print "invalid data.... NAME not found\n";
  exit;
}

#保存してあるファイルの最後のコメント番号と、トータル保存数を調べる
#コメントを送ってくる時はlast_noとtotal_countが送られてくるはずなので、それを信用する
#保存コメントが膨大になると、読み込みが重くなりそうな感じ
if($PostDataArray[0] =~ /^<send /){
  if($PostDataArray[0] =~ /last_no=\"([0-9]+)\" total_count=\"([0-9]+)\"/){
    $last_no = $1 - 0;
    $total_count = $2 - 0;
  }else{
    print "Content-Type: text/plain\n";
    print "\n";
    print "invalid data.... LAST_NO or TOTAL_COUNT not found\n";
    exit;
  }
}

if($PostDataArray[0] =~ /^<count / || $last_no == 0){
  open(XML, "<", $XMLDir . $name . ".xml");
  while(my $xx = <XML>){
    if($xx =~ /^<chat / && $xx =~ / no=\"([0-9]+)\"/){
      $total_count++;
      $last_no = $1 - 0;
    }
  }
  close(XML);
}

if($PostDataArray[0] =~ /^<count /){
  print "Content-Type: text/xml\n";
  print "\n";
  print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
  print '<result last_no="' . $last_no . '" total_count="' . $total_count . '" />';
  exit;
}

#<send />
#last_noより大きい番号のコメントをファイルに追加していく
#ので、過去ログとか送ってきてもシカトされる
#個人的な都合上、コメントごとに改行いれて保存する
#コメント職人系の改行入りコメントとかもカウント自体は間違えないはず
#うちの環境ではPerlの複数起動を許可してないのでロック処理とかしてない
if($PostDataArray[0] =~ /^<send /){
  my $add_count = 0;#追加されたコメントの数
  open(XML, ">>", $XMLDir . $name . ".xml");
  foreach my $xx (@PostDataArray){
    if($xx =~ /^<chat / && $xx =~ / no=\"([0-9]+)\"/){
      if($1 > $last_no){
        print(XML "$xx</chat>\n");
        $total_count++;
        $add_count++;
        $last_no = $1;
      }
    }
  }
  close(XML);

  print "Content-Type: text/xml\n";
  print "\n";
  print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
  print '<result last_no="' . $last_no . '" total_count="' . $total_count . '" add_count="' . $add_count . '" />';
  exit;
}

#<load />
#コメントを送り返す
#<load name="sm123" from="500" to="1499" />
if($PostDataArray[0] =~ /^<load /){
  if($PostDataArray[0] =~ / from=\"(\-?[0-9]+)\" to=\"(\-?[0-9]+)\"/){
    my $from = $1 - 0;
    my $to = $2 - 0;

    open(XML, "<", $XMLDir . $name . ".xml");
    my $read_status = "seek";
    my $num = 0;
    print "Content-Type: text/xml\n";
    print "\n";
    print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
    while(my $xx = <XML>){
      if($xx =~ /^<chat / && $xx =~ / no=\"([0-9]+)\"/){
        $num++;
        if($num >= $from && $num <= $to){$read_status = "get";}
        elsif($num > $to){$read_status = "end";}
      }
      if($read_status eq "get"){
        $xx =~ s/<\/chat>\n/<\/chat>/;
        print $xx;
      }elsif($read_status eq "end"){
        last;
      }
    }
    close(XML);

  }else{
    print "Content-Type: text/plain\n";
    print "\n";
    print "invalid data.... FROM or TO not found\n";
  }
}

    



#close(LOG);
exit;
